/*
 * -----------------------------------------------------------------------
 *
 * NOTE: Do *not* edit this file; instead, edit 'erl_alloc.types' and
 *       build again! This file was automatically generated by
 *       'make_alloc_types' on Tue Jul 15 10:59:04 2008.
 *
 * -----------------------------------------------------------------------
 *
 * ``The contents of this file are subject to the Erlang Public License,
 * Version 1.1, (the "License"); you may not use this file except in
 * compliance with the License. You should have received a copy of the
 * Erlang Public License along with this software. If not, it can be
 * retrieved via the world wide web at http://www.erlang.org/.
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Original Code is Ericsson Utvecklings AB.
 * Portions created by Ericsson are Copyright 1999, Ericsson Utvecklings
 * AB. All Rights Reserved.''
 */

#ifndef ERL_ALLOC_TYPES_H__
#define ERL_ALLOC_TYPES_H__


/* --- Allocator numbers -------------------------------------------------- */

#define ERTS_ALC_A_INVALID (0)

#define ERTS_ALC_A_MIN (1)

#define ERTS_ALC_A_SYSTEM (1)
#define ERTS_ALC_A_TEMPORARY (2)
#define ERTS_ALC_A_SHORT_LIVED (3)
#define ERTS_ALC_A_STANDARD (4)
#define ERTS_ALC_A_LONG_LIVED (5)
#define ERTS_ALC_A_EHEAP (6)
#define ERTS_ALC_A_BINARY (7)
#define ERTS_ALC_A_ETS (8)
#define ERTS_ALC_A_FIXED_SIZE (9)

#define ERTS_ALC_A_MAX (9)


/* --- Class numbers ------------------------------------------------------ */

#define ERTS_ALC_C_INVALID (0)

#define ERTS_ALC_C_MIN (1)

#define ERTS_ALC_C_PROCESSES  (1)
#define ERTS_ALC_C_ETS  (2)
#define ERTS_ALC_C_BINARIES  (3)
#define ERTS_ALC_C_ATOM  (4)
#define ERTS_ALC_C_SYSTEM  (5)
#define ERTS_ALC_C_CODE  (6)

#define ERTS_ALC_C_MAX (6)


/* --- Type number intervals ---------------------------------------------- */

#define ERTS_ALC_N_INVALID (0)

#define ERTS_ALC_N_MIN (1)

/* Type numbers used for sys_alloc */
#define ERTS_ALC_N_MIN_A_SYSTEM (1)
#define ERTS_ALC_N_MAX_A_SYSTEM (7)

/* Type numbers used for temp_alloc */
#define ERTS_ALC_N_MIN_A_TEMPORARY (8)
#define ERTS_ALC_N_MAX_A_TEMPORARY (17)

/* Type numbers used for sl_alloc */
#define ERTS_ALC_N_MIN_A_SHORT_LIVED (18)
#define ERTS_ALC_N_MAX_A_SHORT_LIVED (21)

/* Type numbers used for std_alloc */
#define ERTS_ALC_N_MIN_A_STANDARD (22)
#define ERTS_ALC_N_MAX_A_STANDARD (48)

/* Type numbers used for ll_alloc */
#define ERTS_ALC_N_MIN_A_LONG_LIVED (49)
#define ERTS_ALC_N_MAX_A_LONG_LIVED (64)

/* Type numbers used for eheap_alloc */
#define ERTS_ALC_N_MIN_A_EHEAP (65)
#define ERTS_ALC_N_MAX_A_EHEAP (67)

/* Type numbers used for binary_alloc */
#define ERTS_ALC_N_MIN_A_BINARY (68)
#define ERTS_ALC_N_MAX_A_BINARY (69)

/* Type numbers used for ets_alloc */
#define ERTS_ALC_N_MIN_A_ETS (70)
#define ERTS_ALC_N_MAX_A_ETS (77)

/* Type numbers used for fix_alloc */
#define ERTS_ALC_N_MIN_A_FIXED_SIZE (78)
#define ERTS_ALC_N_MAX_A_FIXED_SIZE (87)

#define ERTS_ALC_N_MAX (87)


/* --- Multi thread use of allocators -------------------------------------- */

#define ERTS_ALC_MTA_SYSTEM (1)
#define ERTS_ALC_MTA_TEMPORARY (0)
#define ERTS_ALC_MTA_SHORT_LIVED (0)
#define ERTS_ALC_MTA_STANDARD (0)
#define ERTS_ALC_MTA_LONG_LIVED (0)
#define ERTS_ALC_MTA_EHEAP (0)
#define ERTS_ALC_MTA_BINARY (1)
#define ERTS_ALC_MTA_ETS (0)
#define ERTS_ALC_MTA_FIXED_SIZE (0)


/* --- Types --------------------------------------------------------------- */

typedef Uint32 ErtsAlcType_t; /* The type used for memory types */

#define ERTS_ALC_T_INVALID (0)

#define ERTS_ALC_T_UNDEF (209)
#define ERTS_ALC_T_DRV (337)
#define ERTS_ALC_T_NBIF_TABLE (465)
#define ERTS_ALC_T_ASYNC (593)
#define ERTS_ALC_T_HIPE (721)
#define ERTS_ALC_T_ENVIRONMENT (849)
#define ERTS_ALC_T_PUTENV_STR (977)
#define ERTS_ALC_T_MSG_ROOTS (1042)
#define ERTS_ALC_T_ROOTSET (1170)
#define ERTS_ALC_T_LOADER_TMP (1378)
#define ERTS_ALC_T_NC_TMP (1490)
#define ERTS_ALC_T_TMP (1618)
#define ERTS_ALC_T_DCTRL_BUF (1746)
#define ERTS_ALC_T_ESTACK (1874)
#define ERTS_ALC_T_DB_TMP (1954)
#define ERTS_ALC_T_DB_MC_STK (2082)
#define ERTS_ALC_T_DB_MPROG_HEAP (2210)
#define ERTS_ALC_T_MSG_REF (2323)
#define ERTS_ALC_T_SL_BIF_TIMER (2451)
#define ERTS_ALC_T_DB_FIXATION (2595)
#define ERTS_ALC_T_DB_FIX_DEL (2723)
#define ERTS_ALC_T_LINK_LH (2836)
#define ERTS_ALC_T_MONITOR_LH (2964)
#define ERTS_ALC_T_NLINK_LH (3092)
#define ERTS_ALC_T_LL_BIF_TIMER (3220)
#define ERTS_ALC_T_REG_TABLE (3412)
#define ERTS_ALC_T_FUN_TABLE (3556)
#define ERTS_ALC_T_DIST_TABLE (3668)
#define ERTS_ALC_T_NODE_TABLE (3796)
#define ERTS_ALC_T_ATOM_TABLE (3908)
#define ERTS_ALC_T_EXPORT_TABLE (4068)
#define ERTS_ALC_T_MODULE_TABLE (4196)
#define ERTS_ALC_T_MODULE_REFS (4324)
#define ERTS_ALC_T_DCACHE (4436)
#define ERTS_ALC_T_DIST_ENTRY (4564)
#define ERTS_ALC_T_NODE_ENTRY (4692)
#define ERTS_ALC_T_DRV_ENTRY_LIST (4820)
#define ERTS_ALC_T_ARG_REG (4884)
#define ERTS_ALC_T_PROC_DICT (5012)
#define ERTS_ALC_T_CALLS_BUF (5140)
#define ERTS_ALC_T_BPD (5332)
#define ERTS_ALC_T_PORT_NAME (5460)
#define ERTS_ALC_T_LINEBUF (5588)
#define ERTS_ALC_T_IOQ (5716)
#define ERTS_ALC_T_BITS_BUF (5844)
#define ERTS_ALC_T_DIST_BUF (5972)
#define ERTS_ALC_T_PORT_CALL_BUF (6100)
#define ERTS_ALC_T_FD_ENTRY_BUF (6228)
#define ERTS_ALC_T_ATOM_TXT (6341)
#define ERTS_ALC_T_BIF_TIMER_TABLE (6485)
#define ERTS_ALC_T_DMSG_BLD_BUF (6613)
#define ERTS_ALC_T_PROC_TABLE (6677)
#define ERTS_ALC_T_PORT_TABLE (6869)
#define ERTS_ALC_T_TMP_BUF (6997)
#define ERTS_ALC_T_TIMER_WHEEL (7125)
#define ERTS_ALC_T_CODE (7269)
#define ERTS_ALC_T_ASYNC_Q (7381)
#define ERTS_ALC_T_DB_TABLES (7461)
#define ERTS_ALC_T_INSTR_INFO (7637)
#define ERTS_ALC_T_DRV_TAB (7765)
#define ERTS_ALC_T_FD_TAB (7893)
#define ERTS_ALC_T_POLL_FDS (8021)
#define ERTS_ALC_T_READY_FDS (8149)
#define ERTS_ALC_T_CS_PROG_PATH (8277)
#define ERTS_ALC_T_HEAP (8342)
#define ERTS_ALC_T_OLD_HEAP (8470)
#define ERTS_ALC_T_HEAP_FRAG (8598)
#define ERTS_ALC_T_DRV_BINARY (8759)
#define ERTS_ALC_T_BINARY (8887)
#define ERTS_ALC_T_DB_SEG (9000)
#define ERTS_ALC_T_DB_SEG_TAB (9128)
#define ERTS_ALC_T_DB_STK (9256)
#define ERTS_ALC_T_DB_TRANS_TAB (9384)
#define ERTS_ALC_T_DB_SEL_LIST (9512)
#define ERTS_ALC_T_DB_DMC_ERROR (9640)
#define ERTS_ALC_T_DB_DMC_ERR_INFO (9768)
#define ERTS_ALC_T_DB_TERM (9896)
#define ERTS_ALC_T_PROC (10009)
#define ERTS_ALC_T_ATOM (10185)
#define ERTS_ALC_T_EXPORT (10345)
#define ERTS_ALC_T_MODULE (10473)
#define ERTS_ALC_T_REG_PROC (10521)
#define ERTS_ALC_T_MONITOR_SH (10649)
#define ERTS_ALC_T_NLINK_SH (10777)
#define ERTS_ALC_T_PROC_LIST (10905)
#define ERTS_ALC_T_FUN_ENTRY (11113)
#define ERTS_ALC_T_DB_TABLE (11177)


/* --- Field sizes, masks, and shifts -------------------------------------- */

#define ERTS_ALC_A_BITS (4)
#define ERTS_ALC_C_BITS (3)
#define ERTS_ALC_N_BITS (7)
#define ERTS_ALC_T_BITS (14)

#define ERTS_ALC_A_MASK (15)
#define ERTS_ALC_C_MASK (7)
#define ERTS_ALC_N_MASK (127)
#define ERTS_ALC_T_MASK (16383)

#define ERTS_ALC_A_SHIFT (0)
#define ERTS_ALC_C_SHIFT (4)
#define ERTS_ALC_N_SHIFT (7)


/* --- Mappings ------------------------------------------------------------ */

/* type -> type number */
#define ERTS_ALC_T2N(T) (((T) >> ERTS_ALC_N_SHIFT) & ERTS_ALC_N_MASK)

/* type -> allocator number */
#define ERTS_ALC_T2A(T) (((T) >> ERTS_ALC_A_SHIFT) & ERTS_ALC_A_MASK)

/* type -> class number */
#define ERTS_ALC_T2C(T) (((T) >> ERTS_ALC_C_SHIFT) & ERTS_ALC_C_MASK)

/* type number -> type */
#define ERTS_ALC_N2T(N) (erts_alc_n2t[(N)])

/* type number -> type description */
#define ERTS_ALC_N2TD(N) (erts_alc_n2td[(N)])

/* type -> type description */
#define ERTS_ALC_T2TD(T) (ERTS_ALC_N2TD(ERTS_ALC_T2N((T))))

/* class number -> class description */
#define ERTS_ALC_C2CD(C) (erts_alc_c2cd[(C)])

/* allocator number -> allocator description */
#define ERTS_ALC_A2AD(A) (erts_alc_a2ad[(A)])

extern const ErtsAlcType_t erts_alc_n2t[];
extern const char *erts_alc_n2td[];
extern const char *erts_alc_c2cd[];
extern const char *erts_alc_a2ad[];

#ifdef ERTS_ALC_INTERNAL__

const ErtsAlcType_t erts_alc_n2t[] = {
  ERTS_ALC_T_INVALID,
  ERTS_ALC_T_UNDEF,
  ERTS_ALC_T_DRV,
  ERTS_ALC_T_NBIF_TABLE,
  ERTS_ALC_T_ASYNC,
  ERTS_ALC_T_HIPE,
  ERTS_ALC_T_ENVIRONMENT,
  ERTS_ALC_T_PUTENV_STR,
  ERTS_ALC_T_MSG_ROOTS,
  ERTS_ALC_T_ROOTSET,
  ERTS_ALC_T_LOADER_TMP,
  ERTS_ALC_T_NC_TMP,
  ERTS_ALC_T_TMP,
  ERTS_ALC_T_DCTRL_BUF,
  ERTS_ALC_T_ESTACK,
  ERTS_ALC_T_DB_TMP,
  ERTS_ALC_T_DB_MC_STK,
  ERTS_ALC_T_DB_MPROG_HEAP,
  ERTS_ALC_T_MSG_REF,
  ERTS_ALC_T_SL_BIF_TIMER,
  ERTS_ALC_T_DB_FIXATION,
  ERTS_ALC_T_DB_FIX_DEL,
  ERTS_ALC_T_LINK_LH,
  ERTS_ALC_T_MONITOR_LH,
  ERTS_ALC_T_NLINK_LH,
  ERTS_ALC_T_LL_BIF_TIMER,
  ERTS_ALC_T_REG_TABLE,
  ERTS_ALC_T_FUN_TABLE,
  ERTS_ALC_T_DIST_TABLE,
  ERTS_ALC_T_NODE_TABLE,
  ERTS_ALC_T_ATOM_TABLE,
  ERTS_ALC_T_EXPORT_TABLE,
  ERTS_ALC_T_MODULE_TABLE,
  ERTS_ALC_T_MODULE_REFS,
  ERTS_ALC_T_DCACHE,
  ERTS_ALC_T_DIST_ENTRY,
  ERTS_ALC_T_NODE_ENTRY,
  ERTS_ALC_T_DRV_ENTRY_LIST,
  ERTS_ALC_T_ARG_REG,
  ERTS_ALC_T_PROC_DICT,
  ERTS_ALC_T_CALLS_BUF,
  ERTS_ALC_T_BPD,
  ERTS_ALC_T_PORT_NAME,
  ERTS_ALC_T_LINEBUF,
  ERTS_ALC_T_IOQ,
  ERTS_ALC_T_BITS_BUF,
  ERTS_ALC_T_DIST_BUF,
  ERTS_ALC_T_PORT_CALL_BUF,
  ERTS_ALC_T_FD_ENTRY_BUF,
  ERTS_ALC_T_ATOM_TXT,
  ERTS_ALC_T_BIF_TIMER_TABLE,
  ERTS_ALC_T_DMSG_BLD_BUF,
  ERTS_ALC_T_PROC_TABLE,
  ERTS_ALC_T_PORT_TABLE,
  ERTS_ALC_T_TMP_BUF,
  ERTS_ALC_T_TIMER_WHEEL,
  ERTS_ALC_T_CODE,
  ERTS_ALC_T_ASYNC_Q,
  ERTS_ALC_T_DB_TABLES,
  ERTS_ALC_T_INSTR_INFO,
  ERTS_ALC_T_DRV_TAB,
  ERTS_ALC_T_FD_TAB,
  ERTS_ALC_T_POLL_FDS,
  ERTS_ALC_T_READY_FDS,
  ERTS_ALC_T_CS_PROG_PATH,
  ERTS_ALC_T_HEAP,
  ERTS_ALC_T_OLD_HEAP,
  ERTS_ALC_T_HEAP_FRAG,
  ERTS_ALC_T_DRV_BINARY,
  ERTS_ALC_T_BINARY,
  ERTS_ALC_T_DB_SEG,
  ERTS_ALC_T_DB_SEG_TAB,
  ERTS_ALC_T_DB_STK,
  ERTS_ALC_T_DB_TRANS_TAB,
  ERTS_ALC_T_DB_SEL_LIST,
  ERTS_ALC_T_DB_DMC_ERROR,
  ERTS_ALC_T_DB_DMC_ERR_INFO,
  ERTS_ALC_T_DB_TERM,
  ERTS_ALC_T_PROC,
  ERTS_ALC_T_ATOM,
  ERTS_ALC_T_EXPORT,
  ERTS_ALC_T_MODULE,
  ERTS_ALC_T_REG_PROC,
  ERTS_ALC_T_MONITOR_SH,
  ERTS_ALC_T_NLINK_SH,
  ERTS_ALC_T_PROC_LIST,
  ERTS_ALC_T_FUN_ENTRY,
  ERTS_ALC_T_DB_TABLE,
  ERTS_ALC_T_INVALID
};

const char *erts_alc_n2td[] = {
  "invalid_type",
  "undefined",
  "drv_internal",
  "nbif_tab",
  "async",
  "hipe_data",
  "environment",
  "putenv_string",
  "msg_roots",
  "root_set",
  "loader_tmp",
  "nc_tmp",
  "tmp",
  "dctrl_buf",
  "estack",
  "db_tmp",
  "db_mc_stack",
  "db_match_prog_heap",
  "msg_ref",
  "bif_timer_sl",
  "db_fixation",
  "fixed_del",
  "link_lh",
  "monitor_lh",
  "nlink_lh",
  "bif_timer_ll",
  "reg_tab",
  "fun_tab",
  "dist_tab",
  "node_tab",
  "atom_tab",
  "export_tab",
  "module_tab",
  "module_refs",
  "dcache",
  "dist_entry",
  "node_entry",
  "drv_entry_list",
  "arg_reg",
  "proc_dict",
  "calls_buf",
  "bpd",
  "port_name",
  "line_buf",
  "io_queue",
  "bits_buf",
  "dist_buf",
  "port_call_buf",
  "fd_entry_buf",
  "atom_text",
  "bif_timer_table",
  "dmsg_buf",
  "proc_tab",
  "port_tab",
  "tmp_buf",
  "timer_wheel",
  "code",
  "async_queue",
  "db_tabs",
  "instr_info",
  "drv_tab",
  "fd_tab",
  "poll_fds",
  "ready_fds",
  "cs_prog_path",
  "heap",
  "old_heap",
  "heap_frag",
  "drv_binary",
  "binary",
  "db_segment",
  "db_segment_tab",
  "db_stack",
  "db_trans_tab",
  "db_select_list",
  "db_dmc_error",
  "db_dmc_error_info",
  "db_term",
  "proc",
  "atom_entry",
  "export_entry",
  "module_entry",
  "reg_proc",
  "monitor_sh",
  "nlink_sh",
  "proc_list",
  "fun_entry",
  "db_tab",
  NULL
};

const char *erts_alc_c2cd[] = {
  "invalid_class",
  "process_data",
  "ets_data",
  "binary_data",
  "atom_data",
  "system_data",
  "code_data",
  NULL
};

const char *erts_alc_a2ad[] = {
  "invalid_allocator",
  "sys_alloc",
  "temp_alloc",
  "sl_alloc",
  "std_alloc",
  "ll_alloc",
  "eheap_alloc",
  "binary_alloc",
  "ets_alloc",
  "fix_alloc",
  NULL
};

#endif /* #ifdef ERTS_ALC_INTERNAL__ */


/* ------------------------------------------------------------------------- */
#endif /* #ifndef ERL_ALLOC_TYPES_H__ */
